#grid.apply <- function(y,f,...,wait=FALSE,varlist=c(),plots=FALSE){

# SOAPRes<-.SOAP(server,\"executeGridR\",rFunctParam=\"",rFunctParam,"\", rFunction=\"",gsub('"', '\\\\\"', rFunction),"\", inputDir=\"\", outputDir=\"\", username=\"mltest\", pwd=\"mltest\", action=\"executeGridR\",.convert=FALSE)

#for(n in names(l)) { cat(n, "\n")}



#source("/home/malte/RWebservice.R") 
#grid.init()
#grid.apply("x",f, 3, wait=TRUE) 
#f is a defined R fuction, 3 is the parameter fo f and the output is written to variable x



grid.consistency <-function() { # check if there are errors in .grid structure 
wd=getwd()	
setwd(.grid$localDir)
jobVars=c()
jobNames=c()
 # check if all running jobs are locked
if(length(.grid$gridJobs)>0)
  for(i in 1:length(.grid$gridJobs)){
	jobVars=append(jobVars, .grid$gridJobs[[i]]$var)
        jobNames=append(jobNames, .grid$gridJobs[[i]]$name)

      if(!.grid$gridJobs[[i]]$var %in% .grid$lock$varName)
	{
	cat("Job ", i, " exists, but variable ", .grid$gridJobs[[i]]$var, "is not locked!\n lock it? (y/n)")
	res=scan(file=stdin(), what=character(0), nmax=1)
	if(res=="y" || res=="yes")
	   grid.writeLock(.grid$gridJobs[[i]]$var)
	}
   }
 # check if all locked jobs exists
if(length(.grid$lock$varName)>0)
   for(i in 1:length(.grid$lock$varName)){
      if(!.grid$lock$varName[i]%in% jobVars)
	{
	cat(.grid$lock$varName[i], "is locked, but Job doesn´t exists!\n unlock? (y/n)\n")
        res=scan(file=stdin(), what=character(0), nmax=1)
	if(res=="y" || res=="yes")
	   grid.unlock(.grid$lock$varName[i])
      }
   }
 # check if there are files without a running job
files=dir()
del=c()
fileJobs=c()
if(length(files)>0)
   for(i in 1:length(files)){
	if(regexpr(paste("^grid-", Sys.info()["nodename"],"[0-9]*-[0-9]*-[0-9]*-[0-9]*-[0-9]*-[0-9]*-[0-9]*-[0-9]*-.*$",sep=""), files[i], perl=TRUE)[1]>0)
	   {# found a jobfile
	   #look if a job to that file exists
	   found=FALSE
	   if(length(jobNames)>0)
	     for(j in 1:length(jobNames))
		if(pmatch(jobNames[j], files[i], nomatch=0)==1)
			found=TRUE
	   if(found==FALSE)
	   {   #no Job found
		del=append(del, files[i])
	   }
	}
	
   }
if(!is.null(del)) 
  {
  print(del)
  cat("no running job for these files found.  Delete all files? (y/n)\n")
  res=scan(file=stdin(), what=character(0), nmax=1)
	if(res=="y" || res=="yes"){
	   for (i in 1:length(del))
		unlink(del[i])
	}
	else {
	     for (i in 1:length(del)) {
		cat("no running Job for File", del[i], "found. Delete this file? (y/n)\n")
		res[i]=scan(file=stdin(), what=character(0), nmax=1)
		if(res[i]=="y" || res[i]=="yes"){
			unlink(del[i])
		}
	     }
	}

  }
setwd(wd)
}

# intern=TRUE => return missing variables or NULL (for internal use) 
# intern=FALSE => return TRUE/FALSE and print Text output
grid.check<- function(f,x="",varlist=c(), fName="", intern=FALSE) {
	if(!any(gregexpr("codetool", library())!=-1)){
		cat("package codetools is missing, please install it or use check=FALSE")
		return(FALSE)
	}
		
wd=getwd()
setwd(.grid$localDir)
end=FALSE
fMissing = paste(.grid$localDir, .grid$uniqueName, "-missing", sep="")
localScript=paste(.grid$localDir, .grid$uniqueName, "-localScript.R", sep="")
codeToolsOld=""

if(fName=="")
{
   fName <- paste(.grid$uniqueName,"-fxc",sep="") #dont overwrite other fName!!!
   save(list=c("f",varlist),file=paste(.grid$localDir,fName,sep=""))
}
while(!end)
{
    script <- paste("load(\"", fName,"\") \n",sep="")
    script <- paste(script, "y=c() \n library(codetools) \n",sep="")
    if(!is.null(varlist))
	for(i in 1:length(varlist))
	      script=paste(script, "if(is.function(",varlist[i],")) checkUsage(",varlist[i],", report=function(s){assign(\"y\",paste(y, s), .GlobalEnv)}) \n", sep="")
    script=paste(script,"checkUsage(f, report=function(s){assign(\"y\",paste(y, s), .GlobalEnv)}) \n save(list=c(\"y\"),file=\"", fMissing, "\")",sep="")

	write.table(script,file=localScript,quote=FALSE,row.names=FALSE,col.names=FALSE)

	system(paste("R CMD BATCH --vanilla ",localScript, sep=""))

	if(file.exists(fMissing))
		load(fMissing)
	else
	{
		cat("Error cannot check for missing variables, file is missing\n")
		end=TRUE
	}
	if(!is.null(y))
	{
		# test if this and the last codetools message is the same => endless loop
		if(y==codeToolsOld)
		{
			cat("loop: cannot load local function/variable:\n", y)
			end=TRUE
			if(!intern)
				return(FALSE)
		}
		else
		{
		codeToolsOld=y
		grepRes=gregexpr("‘", y)[[1]]
		grepResEnd=gregexpr("’", y)[[1]]
		for(k in 1:length(grepRes))
			{
				add=substr(y, grepRes[k]+1, grepResEnd[k]-1)
			#	cat(paste(k,"grep var:",add, "\n"))
				if(exists(add))
					varlist = append(varlist, add)
				else
				{
					cat("cannot load local function/variable:", add, "\n")
					end=TRUE
					if(!intern)
						return(FALSE)
				}	
			}
	
		save(list=c("x","f",varlist),file=fName)
		}
	}
	else
	{
		end=TRUE
	}
}
unlink(localScript)
unlink(paste(localScript,"out", sep=""))
unlink(fMissing)
if(intern)
	return(varlist)
else {
	cat("All variables and functions found\n")
	return(TRUE)
}
setwd(wd)
}

#######################################################################################################
.grid.makeWSFiles <- function(webservice, fName, plots, scriptName, yName, remScriptName, psName, varlist, cmd, outputPath) {
	
	# create script which loads libraries, checks variables and executes the function
	remscript <- "# automatically generated R script from gridR \n"
	if(plots){
		remscript <- append(remscript,"err=try(library(graphics)) ; if(inherits(err, \"try-error\")){
			write.table(\"try-error in RemScript: cannot load library graphics\",file=\"y.dat\", quote=FALSE,row.names=FALSE,col.names=FALSE) };",
				paste("postscript(file=\"",psName,"\")",sep=""))
	}
	remscript <- paste(remscript,"err=try(load(\"rCodeLib\")); if(inherits(err, \"try-error\")){
			write.table(\"try-error in RemScript: cannot load transferred library file \",file=\"y.dat\", quote=FALSE,row.names=FALSE,col.names=FALSE) }
			y=c()
			err=(library(codetools)); if(inherits(err, \"try-error\")){
			write.table(\"try-error in RemScript: cannot load codetools library\",file=\"y.dat\", quote=FALSE,row.names=FALSE,col.names=FALSE) }
			 \n",sep="")
	
	if(!is.null(varlist))
		for(i in 1:length(varlist)){ 
			remscript=paste(remscript, "if(is.function(",varlist[i],")) checkUsage(",varlist[i],", report=function(s){assign(\"y\",paste(y, s), .GlobalEnv)}) \n", sep="")}
	remscript=paste(remscript,"checkUsage(f, report=function(s){assign(\"y\",paste(y, s), .GlobalEnv)}) \n if(is.null(y)) #otherwise checkUsage reports an error \n
					y = try(eval(parse(text=\"",cmd,"\"))) \n save(list=c(\"y\"),file=\"y.dat\")",sep="")
	if(plots){
		remscript <- append(remscript,"dev.off()")
	}
	write.table(remscript,file=paste(.grid$localDir,remScriptName,sep=""),quote=FALSE,row.names=FALSE,col.names=FALSE)
	
	# create local R script which connects to the Webservice and uploads the library file
	if(gregexpr("CondorRWebservice", webservice)[[1]]==1)
	script=paste("return=try(system(\"java -classpath ",.grid$JavaClientPath,.grid$classSeparator,.grid$JavaLibPath,"axis.jar",.grid$classSeparator,.grid$JavaLibPath,"activation.jar",.grid$classSeparator,.grid$JavaLibPath,"jaxrpc.jar",.grid$classSeparator,.grid$JavaLibPath,"commons-logging-1.0.4.jar",.grid$classSeparator,.grid$JavaLibPath,"commons-discovery.jar",.grid$classSeparator,.grid$JavaLibPath,"mail.jar",.grid$classSeparator,.grid$JavaLibPath,"wsdl4j.jar Client ",webservice, " ", .grid$condorUrl, " ", paste(.grid$localDir,remScriptName,sep=""), " ", .grid$localDir,fName, " ", outputPath, "\",intern=TRUE))", sep="")
	else
		if(grep("GlobusRWebservice", webservice)==1)
		script=paste("return=try(system(\"java -classpath ",.grid$JavaClientPath,.grid$classSeparator,.grid$JavaLibPath,"axis.jar",.grid$classSeparator,.grid$JavaLibPath,"activation.jar",.grid$classSeparator,.grid$JavaLibPath,"jaxrpc.jar",.grid$classSeparator,.grid$JavaLibPath,"commons-logging-1.0.4.jar",.grid$classSeparator,.grid$JavaLibPath,"commons-discovery.jar",.grid$classSeparator,.grid$JavaLibPath,"mail.jar",.grid$classSeparator,.grid$JavaLibPath,"wsdl4j.jar Client ",webservice, " ", .grid$globusUrl, " ", paste(.grid$localDir,remScriptName,sep=""), " ", .grid$localDir,fName, " ", outputPath, " ", .grid$globusHost, " ", .grid$myProxyHost, " ",.grid$myProxyUsername, " ",.grid$pwd,"\",intern=TRUE))", sep="")
		else {
			print("wrong webservice in makeWSFiles")
			return();
		}
	script=paste(script, "#look for java errors
					out=scan(file=\"",scriptName,"out\", what=character(0), sep=\"\\n\")
					if(inherits(return, \"try-error\")){
						write.table(\"try-error: cannot connect to webservice, check Java Paths and webservice\",\"",yName,"\",quote=FALSE,row.names=FALSE,col.names=FALSE )
						return(-1)}\n
					if(any(grep(\"^Exception in thread\", out))){
						write.table(\"cannot connect to webservice, check Java Paths and webservice\",\"",yName,"\",quote=FALSE,row.names=FALSE,col.names=FALSE )
						return(-1)}\n	
					#if(!is.null(return))#if not null, then there is an error
					if(!file.exists(\"",yName,"\"))
					   write.table(return,\"",yName,"\",quote=FALSE,row.names=FALSE,col.names=FALSE )", sep="")
	
	write.table(script,scriptName,quote=FALSE,row.names=FALSE,col.names=FALSE)
	
	
}

.grid.makeSshAndCondorFiles <- function(plots, yName, psName, fName, remScriptName, remMainName,remMainNameOut, varlist, cmd, onlyssh) {
	errName<- paste(.grid$uniqueName,"-err",sep="")
	condorName<-paste(.grid$uniqueName,"-script.condor",sep="")
	
	#remote script which loads libraries, checks if all functions and variables exist and then executes the main function. result is written to y
	# this script is executed by condor
	remscript <- "# automatically generated R script from gridR \n"
	if(plots){
	  remscript <- append(remscript,"\nerr=try(library(graphics))
			if(inherits(err, \"try-error\")){
			write.table(\"try-error in RemScript: cannot load library graphics\",file=\"",yName,"\", quote=FALSE,row.names=FALSE,col.names=FALSE) };",
			paste("postscript(file=\"",psName,"\")",sep=""))
 	}
	remscript <- paste(remscript,"err=try(load(\"",fName,"\"))
				
		if(inherits(err, \"try-error\")){
		write.table(\"try-error in RemScript: cannot load fName (...-fx)\",file=\"",yName,"\", quote=FALSE,row.names=FALSE,col.names=FALSE) } 
		y=c() 
		err=try(library(codetools))
		if(inherits(err, \"try-error\")){
		write.table(\"try-error in RemScript: cannot load library codetools\",file=\"",yName,"\", quote=FALSE,row.names=FALSE,col.names=FALSE) } \n",sep="")
	if(!is.null(varlist))
		for(i in 1:length(varlist)){ 
			remscript=paste(remscript, "if(is.function(",varlist[i],")) checkUsage(",varlist[i],", report=function(s){assign(\"y\",paste(y, s), .GlobalEnv)}) \n", sep="")
		}
	remscript=paste(remscript,"checkUsage(f, report=function(s){assign(\"y\",paste(y, s), .GlobalEnv)}) \n if(is.null(y)) #otherwise checkUsage reports an error \n
		y = try(eval(parse(text=\"",cmd,"\"))) 
		if(inherits(err, \"try-error\")){
		write.table(paste(\"try-error in RemScript:\",err),file=\"",yName,"\", quote=FALSE,row.names=FALSE,col.names=FALSE) }
		save(list=c(\"y\"),file=\"",yName,"\")",sep="")
	if(plots){
		remscript <- append(remscript,"dev.off()")
	}
	write.table(remscript,file=paste(.grid$localDir,remScriptName,sep=""),quote=FALSE,row.names=FALSE,col.names=FALSE)
	if(!onlyssh) {
	
	  # create R script which submits the job to condor and waits until the file yName exists
		remMainScript=paste("condorScript=paste(\"Executable     = /usr/bin/R
			Universe       = vanilla
			should_transfer_files = YES
			when_to_transfer_output = ON_EXIT
			arguments      = \\\"CMD BATCH ",remScriptName,"\\\"
			Error          = ",errName,"
			transfer_input_files =",remScriptName,",",fName,"
			transfer_files = ALWAYS
			Queue\", sep=\"\")
			write.table(condorScript,\"", condorName,"\",quote=FALSE,row.names=FALSE,col.names=FALSE)
			err=try(system(\"condor_submit ",condorName,"\", intern=TRUE))
			#look for condor errors
			out=scan(file=\"",remMainNameOut,"\", what=character(0), sep=\"\\n\")
			if(inherits(err, \"try-error\")) {
			write.table(\"remMainScript: cannot start condor_submit\",file=\"", yName,"\",quote=FALSE,row.names=FALSE,col.names=FALSE)}
			if(any(grep(\"^ERROR:\", out))) {
			write.table(paste(\"Condor:\", grep(\"^ERROR:\", out, value=TRUE)),file=\"", yName,"\",quote=FALSE,row.names=FALSE,col.names=FALSE)}
			if(any(grep(\"^WARNING:\", out))) {
			write.table(paste(\"Condor:\", grep(\"^WARNING:\", out, value=TRUE)),file=\"", yName,"\",quote=FALSE,row.names=FALSE,col.names=FALSE)}
			while(!file.exists(\"",yName,"\")){
			err=scan(file=\"",errName,"\", what=character(0), quiet=TRUE )
			if(length(err)>0) {
				write.table(paste(\"Condor error: \",err, sep=\"\"), file=\"", yName,"\",quote=FALSE,row.names=FALSE,col.names=FALSE)}
			else
				Sys.sleep(5)
			}
			unlink(\"",errName,"\")
			#unlink(\"",condorName,"\")
			unlink(\"",fName,"\")
			unlink(\"",remScriptName,"\")
			unlink(\"",paste(remScriptName,"out", sep=""),"\")
			", sep="")
		write.table(remMainScript, remMainName,quote=FALSE,row.names=FALSE,col.names=FALSE)
	}
	else{
		# only create ssh file
		remMainScript=paste("source(\"",remScriptName,"\")", sep="");
		write.table(remMainScript, remMainName,quote=FALSE,row.names=FALSE,col.names=FALSE)
	}
}

#checks remote which variables and functions are used, if some are missing the job is retransferred.
grid.apply <- function(y=NULL,f=NULL,... ,wait=FALSE,varlist=c(),plots=FALSE, run=1, check=TRUE){ 

	if(is.null(y)|| is.null(f)){
		cat("wrong usage of grid.apply: first parameter is the variable where to write the output, second is the function, followed by the parameter(s) of the function\n")
		return(FALSE)
	}
	wd=getwd()
	setwd(.grid$localDir)
	
if(y %in% .grid$lock$varName){
  cat(y, " has a writeLock: please use a different variable\n")
  return(FALSE)
}
if(!is.function(f)){
	cat("The parameter specified for the function is not a function!\n")
	return(FALSE)
}

   x <- list(...)
  .grid$uniqueName <- paste("grid",Sys.info()["nodename"],Sys.getpid(),gsub(" |:","-",perl=TRUE,as.character(Sys.time())),.grid$count,sep="-")
  scriptName <- paste(.grid$uniqueName,"-script.R",sep="")
  remMainName <- paste(.grid$uniqueName,"-RemMainScript.R",sep="")
  yName <- paste(.grid$uniqueName,"-y.dat",sep="")
  remScriptName <- paste(.grid$uniqueName,"-Remscript.R",sep="")
  fName <- paste(.grid$uniqueName,"-fx",sep="")
  psName <- paste(.grid$uniqueName,"-plot.ps",sep="")
  save(list=c("x","f",varlist),file=paste(.grid$localDir,fName,sep=""))
  
  #cmd is the function ( ie. f(x[[1]])) which should be executed
 cmd <- paste("f(",sep="")
  if(length(x) > 0){
    cmd <- paste(cmd,"x[[1]]",sep="")
    if(length(x) > 1){
      for(i in 2:length(x)){
        cmd <- paste(cmd,",x[[",i,"]]",sep="")
      }
    }
  }
  cmd <- paste(cmd,")",sep="")

if(check)
		varlist = grid.check(f,x,varlist, paste(.grid$localDir,fName,sep=""), intern=TRUE)
  newGrid <- .grid
  newGrid$count <- newGrid$count+1
  jobs <- .grid$gridJobs
  jobs[[length(jobs)+1]] <- list(name=.grid$uniqueName,var=y,envir=environment(), wait=wait, run=run, plots=plots, varlist= varlist, check=check, service=.grid$service, codeToolsOld="")
  newGrid$gridJobs <- jobs
  assign(".grid",newGrid,.GlobalEnv)

if(.grid$service=="globus.ws")
{
	.grid.makeWSFiles("GlobusRWebservice", fName, plots, scriptName, yName, remScriptName, psName, varlist, cmd, paste(.grid$localDir,yName,sep=""))

	#start local R script that connects to the webservice 
  if(wait){
    system(paste("R CMD BATCH --vanilla ",paste(.grid$localDir,scriptName,sep=""), sep=""))
    .grid$tmp=.grid.callback()

  }
  else{
     grid.writeLock(y)
	 if(gregexpr("linux", .grid$system)[[1]]==1)
      system(paste("R CMD BATCH --vanilla ",paste(.grid$localDir,scriptName,sep=""), " &", sep=""))
  	else
		system(paste("cmd /c start R CMD BATCH --vanilla ",paste(.grid$localDir,scriptName,sep=""), sep=""))
  }

}
else if(.grid$service=="condor.ssh")
{
.grid.makeSshAndCondorFiles(plots, yName, psName, fName, remScriptName, remMainName,paste(remMainName, "out",sep=""), varlist, cmd, FALSE)

# make remote dir and copy files
system(paste("ssh ",.grid$ssh$username,"@",.grid$ssh$ip," \"mkdir ",.grid$ssh$remotePath,"\"", sep=""), ignore.stderr=TRUE)
  a=system(paste("scp ",remScriptName, " ",remMainName, " ", fName," ",.grid$ssh$username,"@", .grid$ssh$ip,":",.grid$ssh$remotePath, sep=""), intern=TRUE)

if(wait) {
	# start remote script and copy file back
  system(paste("ssh ",.grid$ssh$username,"@",.grid$ssh$ip," \"cd ",.grid$ssh$remotePath," && R CMD BATCH ", remMainName,"\"", sep=""))
  a=system(paste("scp ",.grid$ssh$username,"@", .grid$ssh$ip,":",.grid$ssh$remotePath,yName," ", yName, sep=""),intern=TRUE)
  .grid.callback()
 }
 else
 {
	 grid.writeLock(y)
	 #start remote script
	 system(paste("ssh -f ",.grid$ssh$username,"@",.grid$ssh$ip," \"cd ",.grid$ssh$remotePath," && R CMD BATCH ", remMainName,"\"", sep=""))#, intern=TRUE)
	 
 }
}
 else if(.grid$service=="remote.ssh")
 {
	 .grid.makeSshAndCondorFiles(plots, yName, psName, fName, remScriptName, remMainName,paste(remMainName, "out",sep=""), varlist, cmd, TRUE)
	 
# make remote dir and copy files
	 system(paste("ssh ",.grid$ssh$username,"@",.grid$ssh$ip," \"mkdir ",.grid$ssh$remotePath,"\"", sep=""), ignore.stderr=TRUE)
	 a=system(paste("scp ",remScriptName, " ",remMainName, " ", fName," ",.grid$ssh$username,"@", .grid$ssh$ip,":",.grid$ssh$remotePath, sep=""), intern=TRUE)
	 
	 if(wait) {
		 # start remote script and copy file back
		 system(paste("ssh ",.grid$ssh$username,"@",.grid$ssh$ip," \"cd ",.grid$ssh$remotePath," && R CMD BATCH ", remMainName,"\"", sep=""))
		 a=system(paste("scp ",.grid$ssh$username,"@", .grid$ssh$ip,":",.grid$ssh$remotePath,yName," ", yName, sep=""),intern=TRUE)
		 .grid.callback()
	 }
 	else
	{
  		grid.writeLock(y)
  		#start remote script
  		system(paste("ssh -f ",.grid$ssh$username,"@",.grid$ssh$ip," \"cd ",.grid$ssh$remotePath," && R CMD BATCH ", remMainName,"\"", sep=""))#, intern=TRUE)
 	}
}
else if(.grid$service=="condor.ws")
{
	.grid.makeWSFiles("CondorRWebservice", fName, plots, scriptName, yName, remScriptName, psName, varlist, cmd, paste(.grid$localDir,yName,sep=""))
	
	if(wait){
		system(paste("R CMD BATCH --vanilla ",paste(.grid$localDir,scriptName,sep=""), sep=""))
		.grid$tmp=.grid.callback()
		
	}
	else{
		grid.writeLock(y)
		if(gregexpr("linux", .grid$system)[[1]]==1)
		    system(paste("R CMD BATCH --vanilla ",paste(.grid$localDir,scriptName,sep=""), " &", sep=""))
		else
			system(paste("cmd /c start R CMD BATCH --vanilla ",paste(.grid$localDir,scriptName,sep=""), sep=""))
	}
}
setwd(wd)
}


grid.init <- function(localTmpDir=NULL, verbose=TRUE, sshRemoteIp=NULL, globusUrl=NULL, condorUrl=NULL, sshUsername=NULL, sshRemoteDir=NULL, myProxyHost=NULL, myProxyUsername=NULL, myProxyPwd=NULL, javaLibPath=NULL, javaClientPath=NULL, globusExecutionHost=NULL, service=NULL){
  
	.grid <- list()
	configPath=""
	if(file.access("~/.gridr.conf")==0) 
		configPath=	"~/.gridr.conf" 
	if(file.access(".gridr.conf")==0) 
		configPath=	".gridr.conf"
	if(file.access("~/gridr.conf")==0) 
		configPath=	"~/gridr.conf" 
	if(file.access("gridr.conf")==0) 
		configPath=	"gridr.conf"
	if(file.access("~/.eclipse/GridRClient/R/gridr.conf")==0) 
		configPath=	"~/.eclipse/GridRClient/R/gridr.conf" 
	if(configPath=="")
	{
		cat("no config File found\n")
	}
	else {
		#open config file
		config=scan(configPath, what=character(0), quiet=TRUE, sep="\n")
		if(length(config)<2)
		{
			print(paste("wrong config file ( lines <2)", configPath))
			return(FALSE)
		}
		for(i in 1:(length(config)-1)){
			#scan line 2 to end-1
			
			#found a comment?
			if(substr(config[i],1,1)=="#")
				next
			start=gregexpr("<", config[i])[[1]] #find all < 
			end=gregexpr(">", config[i])[[1]]   # find all >
#			print(paste("start:", start))
#			print(paste("end:", end ))
#			print("next i")
			if(i==1) {
				if(gregexpr("<GRIDR>",config[i])[[1]]==-1){
					cat("wrong config file( first line != <GRIDR>\n")
					return(FALSE)
				}
				else
					next
			} else if(length(start)!=length(end) ||length(end)!=2) {#check if number of start and end tags are differen or if there are more than 2 tags per line
				if(length(end)==1 && gregexpr("</GRIDR>",config[i])[[1]]!=-1)
					break
				else
					cat("Syntax error in line ", i, " wrong < and >\n")
			}
			#look if start and end tag are the same
			tag=substr(config[i],start[1]+1, end[1]-1) 
			str=substr(config[i],start[2]+2, end[2]-1)
			if(tag!=str) {
				cat("Syntax error in line ", i, " start and end tag are different\n")
				return(FALSE)
			}
			
			value=substr(config[i],end[1]+1, start[2]-1)
			#delete " " at the beginning
			if(nchar(value)>1 && substr(value,1,1)==" ")
				value=substr(value,2,nchar(value))
			#delete " " at the end
			if(nchar(value)>1 && substr(value,nchar(value),nchar(value))==" ")
				value=substr(value,nchar(value)-1,nchar(value)-1)
		#	save readed values from config file to the right variable
			if(tag=="LOCALTMPDIR")
				.grid$localDir=value
			else if(tag=="GLOBUSWSURL")
				.grid$globusUrl=value 
			else if(tag=="CONDORWSURL")
				.grid$condorUrl=value
			else if(tag=="SSHREMOTEIP")
				.grid$ssh$ip=value
			else if(tag=="SSHUSERNAME")
				.grid$ssh$username=value
			else if(tag=="MYPROXYUSERNAME")
				.grid$myProxyUsername=value
			else if(tag=="MYPROXYPWD")
				.grid$pwd=value
			else if(tag=="SSHREMOTEDIR")
				.grid$ssh$remotePath=value
			else if(tag=="JAVALIBPATH")
				.grid$JavaLibPath=value
			else if(tag=="JAVACLIENTPATH")
				.grid$JavaClientPath=value
			else if(tag=="GLOBUSEXECUTIONHOST")
				.grid$globusHost=value
			else if(tag=="MYPROXYHOST")
				.grid$myProxyHost=value
			else if(tag=="SERVICE")
				.grid$service=value
			
		}
	}
	#save command line parameters to the right variable
  if(!is.null(service))
	  .grid$service<- service
  if(!is.null(localTmpDir))
	  .grid$localDir <- localTmpDir
  if(!is.null(sshRemoteIp))
	  .grid$ssh$ip=sshRemoteIp
  if(!is.null(condorUrl))
	  .grid$condorUrl=condorUrl
  if(!is.null(globusUrl))
	  .grid$globusUrl=globusUrl
  if(!is.null(sshRemoteDir))
	  .grid$ssh$remotePath=sshRemoteDir
  if(!is.null(javaClientPath))
	  .grid$JavaClientPath=javaClientPath
  if(!is.null(javaLibPath))
	  .grid$JavaLibPath=javaLibPath
  if(!is.null(globusExecutionHost))
	  .grid$globusHost=globusExecutionHost
  if(!is.null(sshUsername))
	  .grid$ssh$username=sshUsername
  if(!is.null(myProxyHost))
	  .grid$myProxyHost=myProxyHost
  if(!is.null(myProxyUsername))
	  .grid$myProxyUsername=myProxyUsername
  if(!is.null(myProxyPwd))
	  .grid$pwd=myProxyPwd
  
#check if all needed parameters are entered
	
	if(!(.grid$service=="condor.ssh" || .grid$service =="remote.ssh" || .grid$service =="globus.ws" || .grid$service=="condor.ws" ||.grid$service=="acgt.ws"))
	{
		cat("wrong service, availible services are: condor.ssh, remote.ssh, globus.ws, condor.ws (and acgt.ws)\n")
		return(FALSE)
	}
	err=FALSE
  if(is.null(.grid$service)){
	  cat("service is not specified. Check Config File and Parameters\n")
	  err=TRUE
	  }
  if(is.null(.grid$localDir) || file.access(.grid$localDir)==-1){
	  cat("localTmpDir is not specified or the specified directory does not exist. Check config file and parameters.\n")
	  err=TRUE
	  }
  if (is.null(.grid$ssh$ip) && (.grid$service=="condor.ssh" ||.grid$service=="remote.ssh" )) {
	  cat("sshRemoteIp is not specified. Check Config File and Parameters\n")
	  err=TRUE
	  }

  if(is.null(.grid$condorUrl) && .grid$service=="condor.ws" ) {
	  cat("condorUrl is not specified. Check Config File and Parameters\n")
	  err=TRUE
	  }
	  
  if(is.null(.grid$globusUrl) && ( .grid$service=="globus.ws" || .grid$service=="acgt.ws") ) {
	  cat("globusUrl is not specified. Check Config File and Parameters\n")
	  err=TRUE
  }
	  
  if (is.null(.grid$ssh$remotePath) && (.grid$service=="condor.ssh" ||.grid$service=="remote.ssh" )) {
	  cat("sshRemoteDir is not specified. Check Config File and Parameters\n")
	  err=TRUE
	  }
   if(is.null(.grid$JavaClientPath) && !(.grid$service=="condor.ssh" || .grid$service=="remote.ssh" )){
	   cat("javaClientPath is not specified. Check Config File and Parameters\n")
	   err=TRUE
	   }
   if(is.null(.grid$JavaLibPath) && !(.grid$service=="condor.ssh" || .grid$service=="remote.ssh" )){
	   cat("javaLibPath is not specified. Check Config File and Parameters\n")
	   err=TRUE
	   }
	if(is.null(.grid$myProxyUsername) && ( .grid$service=="globus.ws" || .grid$service=="acgt.ws") ) {
		cat("myProxyUsername is not specified. Check Config File and Parameters\n")
		err=TRUE
		}
	if(is.null(.grid$myProxyHost) && ( .grid$service=="globus.ws" || .grid$service=="acgt.ws") ) {
		cat("myProxyHost is not specified. Check Config File and Parameters\n")
		err=TRUE
	}
	if(is.null(.grid$globusHost) && ( .grid$service=="globus.ws" || .grid$service=="acgt.ws") ) {
		cat("globusExecutionHost is not specified. Check Config File and Parameters\n")
		err=TRUE
	}
	if(is.null(.grid$ssh$username) && (.grid$service=="condor.ssh" ||.grid$service=="remote.ssh" )){
		cat("sshUsername is not specified. Check Config File and Parameters\n")
		err=TRUE
	}
	if(is.null(.grid$pwd) && ( .grid$service=="globus.ws" || .grid$service=="acgt.ws") ) {
	  cat("myProxyPwd is not specified. Check Config File and Parameters\n")
	  err=TRUE
  }
  if(err)
	  return(FALSE)
  
  .grid$count <- 0
  .grid$uniqueName <- paste("grid",Sys.info()["nodename"],Sys.getpid(),gsub(" |:","-",perl=TRUE,as.character(Sys.time())),.grid$count,sep="-")
  .grid$gridJobs <- list()
  .grid$callback <- addTaskCallback(.grid.callback)
  .grid$verbose <- verbose
  .grid$lock <- list(varName=c(),writeLock=c(),value=list(),count=c(),exists=c())
  
  #add / to the end of dirs if not exists
  if(substring(.grid$localDir,nchar(.grid$localDir)) != "/"){ .grid$localDir <- paste(.grid$localDir,"/",sep="") }
  
  if(.grid$service=="condor.ssh" || .grid$service=="remote.ssh") {
      if(substring(.grid$ssh$remotePath,nchar(.grid$ssh$remotePath)) != "/"){ .grid$ssh$remotePath <- paste(.grid$ssh$remotePath,"/",sep="") }
  }
  else {
    if(substring(.grid$JavaLibPath,nchar(.grid$JavaLibPath)) != "/"){ .grid$JavaLibPath <- paste(.grid$JavaLibPath,"/",sep="") }
    if(substring(.grid$JavaClientPath,nchar(.grid$JavaClientPath)) != "/"){ .grid$JavaClientPath <- paste(.grid$JavaClientPath,"/",sep="") }
  }
  #init classpath separator for different operating systems
  if(Sys.info()["sysname"]=="Linux"){
  		.grid$classSeparator=":"
		.grid$system="linux"
	}
   else if(Sys.info()["sysname"]=="Windows"){
	   .grid$classSeparator=";"
	   .grid$system="windows"
	   if(gregexpr("ssh", .grid$service)[[1]]!=-1 ){
		   cat("only on linux systems *.ssh services are availible")
		   return(FALSE)
	   }
   }
   else{
	   cat(paste("wrong Operating System, availible are: \"windows\" and \"linux\"\n your Operating system is: ",Sys.info()["sysname"] ))
	   return(FALSE)
   }
   		
  assign(".grid",.grid,.GlobalEnv)
}


# returns true if a job is ready
.grid.callback <- function(...){
  # see if something is to do
  reapply=FALSE			#if it is set to TRUE the job will be reapply
  del=TRUE
  jobs <- .grid$gridJobs
  i <- 1
  while(i <= length(jobs)){
      filename <- paste(.grid$localDir,jobs[[i]]$name,"-y.dat",sep="")
      remOutput= paste(jobs[[i]]$name,"-y.dat",sep="")
	  
     if(jobs[[i]]$service=="condor.ssh" || jobs[[i]]$service=="remote.ssh")
     {
		 #if this Job is a condor.ssh job look if the remote job is ready and if yes, transfer the file
		tmp=system(paste("ssh ",.grid$ssh$username,"@",.grid$ssh$ip," \"cd ",.grid$ssh$remotePath," && ls \"",sep=""), intern=TRUE)
		if(remOutput %in% tmp) {
			system(paste("scp ",.grid$ssh$username,"@",.grid$ssh$ip,":",.grid$ssh$remotePath, remOutput," ",.grid$localDir,"/",sep=""), intern=TRUE)
		system(paste("ssh ",.grid$ssh$username,"@",.grid$ssh$ip," \"cd ",.grid$ssh$remotePath," && rm ",jobs[[i]]$name,"*\"",sep=""), intern=TRUE)
		}
     }	
     if(file.exists(filename)){

      # what to do if job failed?
      Sys.sleep(1)
      grid.unlock(jobs[[i]]$var)
      warn=getOption("warn")
	  options(warn=-1)
	#try to load the returned file. if there is a error, then the remote task had an error. the error is printed to this file
  	err=try(load(file=filename), silent=TRUE)
	options(warn=warn)
	if(inherits(err, "try-error")) {
		if(file.info(filename)$size==0){
			cat(paste("Grid job had error, see ", .grid$localDir,jobs[[i]]$name, "-script.Rout\n", sep=""))
			del=FALSE
		}
		else {
			res = scan(file=filename, what=character(0), sep="\n", quiet=TRUE )
			warn=getOption("warn")
			options(warn=-1)
			if(length(res)==1 && file.exists(res)) { # no error, webservice response, load that file. res = path to file
		#		cat(res, "\n")
				load(res)
				unlink(res)
			}
			else {
				cat("Grid job had error: ")
				cat(res)
				cat(paste("\n see ", .grid$localDir,jobs[[i]]$name, "-script.Rout\n", sep=""))
				del=FALSE
			}
			options(warn=warn)
		}
	}
      if(del)  # if no error
	{
	   if(inherits(y, "try-error")){

        	cat("Grid job had try-error, see variable ",jobs[[i]]$var,"for more information\n")
	   }
	   # return of codetools that something is missing?
	  else 
	  {
	  	if(regexpr(" <anonymous>: no visible binding for global variable ",y)[1]>0 || regexpr(" <anonymous>: no visible global function definition for ",y)[1]>0)  
  		{
			# test if this and the last codetools message is the same => endless loop
			if(y==jobs[[i]]$codeToolsOld)
			{
				cat("cannot load local function/variable:\n", y)
			}
			else
				jobs[[i]]$codeToolsOld=y
			
			jobs[[i]]$run=jobs[[i]]$run+1
			# the missing objects are between ‘ and ’
			grepRes=gregexpr("‘", y)[[1]]
			grepResEnd=gregexpr("’", y)[[1]]
	
			#load values for f , x, varlist
			load(paste(.grid$localDir,jobs[[i]]$name,"-fx",sep=""))
			if(length(grepRes)>1)
	 		{
			   for(k in 1:length(grepRes))
			   jobs[[i]]$varlist = append(jobs[[i]]$varlist, substr(y, grepRes[k]+1, grepResEnd[k]-1))
		      	}
			else
			{
				# the missing objects are between ' '
				grepRes=gregexpr("'", y)[[1]]
		
				for(k in 1:(length(grepRes)/2))
				jobs[[i]]$varlist = append(jobs[[i]]$varlist, substr(y, grepRes[2*k-1]+1, grepRes[2*k]-1))
			}
			if(length(grepRes)<1)
				cat("variable or function is missing and cannot extract name")
			else
			{
				cat("Variables",jobs[[i]]$varlist,"was missing in Grid call, restarting ...\n")
				
				#save varialbes for reapply
				var=jobs[[i]]$var
				plots=jobs[[i]]$plots
				run=jobs[[i]]$run
				wait=jobs[[i]]$wait
				varl=jobs[[i]]$varlist
				check=jobs[[i]]$check
				reapply=TRUE
			}
      		}#if no error:
     		 else if(.grid$verbose){
        		cat("Grid job finished, result written to variable",jobs[[i]]$var,"\n") 
		#		cat(eval(parse(text=y)), "\n")
				
     		 }
    	}
      	assign(jobs[[i]]$var,y,.GlobalEnv)
      }
	  if(!del) 
		  del=TRUE
		else
			 #delete all files of this job
      		unlink(paste(.grid$localDir,jobs[[i]]$name,"-*",sep=""))
      jobs <- jobs[setdiff(1:length(jobs),i)]

      if(reapply)
		i=length(jobs)+1
    }
    else{
   	i <- i+1
    }
  }
  newGrid <- .grid
  newGrid$gridJobs <- jobs
  assign(".grid",newGrid,.GlobalEnv)

#execute job with missing variables:
  if(reapply)
	{
		grid.apply(var, f, x[[1]], wait=wait, plots=plots, run=run, varlist=varl, check=check)
		reapply=FALSE
	}

 # return(FALSE)
	return(TRUE)
}

grid.printJobs <- function(){
.grid$gridJobs
  if(length(.grid$gridJobs) > 0){
    cat("\nRunning jobs:\n")
    for(i in 1:length(.grid$gridJobs)){
      cat(i,":",.grid$gridJobs[[i]]$var," --- ", .grid$gridJobs[[i]]$name,"\n",sep="")
    }
  }
  else{
    cat("\nNo running jobs:\n")
  }
	cat("\n\n")
#	print(.grid)
}

grid.writeLock <- function(varName){
  # test if write-locked
  if(varName %in% .grid$lock$varName){
    stop(paste("Object"+varName+"has lock"))
  }
  else{
    # do locking
    ex <- exists(varName)
    if(! ex){
      assign(varName,NULL,.GlobalEnv)
    }
    val <- eval(parse(text=varName))
    functionname <- paste(".gridlock.",varName,sep="")
    #f <- function(...){
    #  .grid.callback()
    #  stop(paste("Object"+varName+"has write lock from grid function"))
    #}
	#text <- paste(functionname,"<- function(...){ .grid.callback()\n stop(paste(\"Object\",varName,\"has write lock from grid function\")) }")
    text <- paste(functionname,"<- function(...){ paste(\"Object\",varName,\"has write lock from grid function\"\n) }")
    eval(parse(text=text))
    rm(list=varName,pos=1)
    makeActiveBinding(varName,eval(parse(text=functionname)),.GlobalEnv)

    i <- length(.grid$lock$varName)+1
    .grid$lock$varName[i] <- varName
    .grid$lock$writeLock[i] <- TRUE
    .grid$lock$value[[i]] <- val
    .grid$lock$count[i] <- 1
    .grid$lock$exists[i] <- ex
    assign(".grid",.grid,.GlobalEnv)
  }
}

grid.unlock <- function(varName,all=FALSE){
  if(varName %in% .grid$lock$varName){
    i <- which(.grid$lock$varName == varName,arr.ind=TRUE)[1]
    # reduce lock count
    .grid$lock$count[i] <-  .grid$lock$count[i]-1
    if(all || (.grid$lock$count[i] <= 0)){
      # remove lock
      rm(list=varName,pos=1)
      if(.grid$lock$exists[i]){
        assign(varName,.grid$lock$value[[i]],.GlobalEnv)
      }
      ii <- setdiff(1:length(.grid$lock$varName),i)
      .grid$lock$varName <- .grid$lock$varName[ii]
      .grid$lock$writeLock <- .grid$lock$writeLock[ii]
      .grid$lock$value <- .grid$lock$value[ii]
      .grid$lock$count <- .grid$lock$count[ii]
      .grid$lock$exists <- .grid$lock$exists[ii]
    }
    assign(".grid",.grid,.GlobalEnv)
  }
}

grid.exit <- function(){
  # TODO add try-block
  if(exists(".grid")){
    grid.unlockAll()
    removeTaskCallback(.grid$callback)
    rm(.grid,envir=.GlobalEnv)
  }
}

grid.unlockAll <- function(){
  varNames <- .grid$lock$varName
  for(vn in varNames){
    grid.unlock(vn,all=TRUE)
  }
}

grid.getPassword <- function(){ 
    require(tcltk) 
    tt <- tktoplevel() 
    pass=tclVar("") 
    label.widget <- tklabel(tt, text="Enter Password")
    password.widget <- tkentry(tt,show="*",textvariable=pass)
    ok <- tkbutton(tt,text="Ok",command=function()tkdestroy(tt))
    tkpack(label.widget, password.widget,ok)
    tkwait.window(tt) 
    return(tclvalue(pass)) 
 }
